/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventMessageDataTemplate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventMessageDataTemplate{}

// WebhookEventMessageDataTemplate struct for WebhookEventMessageDataTemplate
type WebhookEventMessageDataTemplate struct {
	Type TemplateType `json:"type"`
	Internal *InternalTemplate `json:"internal,omitempty"`
	// The map of any string values used for cutom external references. 
	InternalComponents *map[string]string `json:"internal_components,omitempty"`
	Whatsapp *WhatsAppTemplate `json:"whatsapp,omitempty"`
	WhatsappComponents []WhatsAppTemplateMessageComponent `json:"whatsapp_components,omitempty"`
}

// NewWebhookEventMessageDataTemplate instantiates a new WebhookEventMessageDataTemplate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventMessageDataTemplate(type_ TemplateType) *WebhookEventMessageDataTemplate {
	this := WebhookEventMessageDataTemplate{}
	this.Type = type_
	return &this
}

// NewWebhookEventMessageDataTemplateWithDefaults instantiates a new WebhookEventMessageDataTemplate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventMessageDataTemplateWithDefaults() *WebhookEventMessageDataTemplate {
	this := WebhookEventMessageDataTemplate{}
	return &this
}

// GetType returns the Type field value
func (o *WebhookEventMessageDataTemplate) GetType() TemplateType {
	if o == nil {
		var ret TemplateType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageDataTemplate) GetTypeOk() (*TemplateType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *WebhookEventMessageDataTemplate) SetType(v TemplateType) {
	o.Type = v
}

// GetInternal returns the Internal field value if set, zero value otherwise.
func (o *WebhookEventMessageDataTemplate) GetInternal() InternalTemplate {
	if o == nil || IsNil(o.Internal) {
		var ret InternalTemplate
		return ret
	}
	return *o.Internal
}

// GetInternalOk returns a tuple with the Internal field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageDataTemplate) GetInternalOk() (*InternalTemplate, bool) {
	if o == nil || IsNil(o.Internal) {
		return nil, false
	}
	return o.Internal, true
}

// HasInternal returns a boolean if a field has been set.
func (o *WebhookEventMessageDataTemplate) HasInternal() bool {
	if o != nil && !IsNil(o.Internal) {
		return true
	}

	return false
}

// SetInternal gets a reference to the given InternalTemplate and assigns it to the Internal field.
func (o *WebhookEventMessageDataTemplate) SetInternal(v InternalTemplate) {
	o.Internal = &v
}

// GetInternalComponents returns the InternalComponents field value if set, zero value otherwise.
func (o *WebhookEventMessageDataTemplate) GetInternalComponents() map[string]string {
	if o == nil || IsNil(o.InternalComponents) {
		var ret map[string]string
		return ret
	}
	return *o.InternalComponents
}

// GetInternalComponentsOk returns a tuple with the InternalComponents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageDataTemplate) GetInternalComponentsOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.InternalComponents) {
		return nil, false
	}
	return o.InternalComponents, true
}

// HasInternalComponents returns a boolean if a field has been set.
func (o *WebhookEventMessageDataTemplate) HasInternalComponents() bool {
	if o != nil && !IsNil(o.InternalComponents) {
		return true
	}

	return false
}

// SetInternalComponents gets a reference to the given map[string]string and assigns it to the InternalComponents field.
func (o *WebhookEventMessageDataTemplate) SetInternalComponents(v map[string]string) {
	o.InternalComponents = &v
}

// GetWhatsapp returns the Whatsapp field value if set, zero value otherwise.
func (o *WebhookEventMessageDataTemplate) GetWhatsapp() WhatsAppTemplate {
	if o == nil || IsNil(o.Whatsapp) {
		var ret WhatsAppTemplate
		return ret
	}
	return *o.Whatsapp
}

// GetWhatsappOk returns a tuple with the Whatsapp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageDataTemplate) GetWhatsappOk() (*WhatsAppTemplate, bool) {
	if o == nil || IsNil(o.Whatsapp) {
		return nil, false
	}
	return o.Whatsapp, true
}

// HasWhatsapp returns a boolean if a field has been set.
func (o *WebhookEventMessageDataTemplate) HasWhatsapp() bool {
	if o != nil && !IsNil(o.Whatsapp) {
		return true
	}

	return false
}

// SetWhatsapp gets a reference to the given WhatsAppTemplate and assigns it to the Whatsapp field.
func (o *WebhookEventMessageDataTemplate) SetWhatsapp(v WhatsAppTemplate) {
	o.Whatsapp = &v
}

// GetWhatsappComponents returns the WhatsappComponents field value if set, zero value otherwise.
func (o *WebhookEventMessageDataTemplate) GetWhatsappComponents() []WhatsAppTemplateMessageComponent {
	if o == nil || IsNil(o.WhatsappComponents) {
		var ret []WhatsAppTemplateMessageComponent
		return ret
	}
	return o.WhatsappComponents
}

// GetWhatsappComponentsOk returns a tuple with the WhatsappComponents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageDataTemplate) GetWhatsappComponentsOk() ([]WhatsAppTemplateMessageComponent, bool) {
	if o == nil || IsNil(o.WhatsappComponents) {
		return nil, false
	}
	return o.WhatsappComponents, true
}

// HasWhatsappComponents returns a boolean if a field has been set.
func (o *WebhookEventMessageDataTemplate) HasWhatsappComponents() bool {
	if o != nil && !IsNil(o.WhatsappComponents) {
		return true
	}

	return false
}

// SetWhatsappComponents gets a reference to the given []WhatsAppTemplateMessageComponent and assigns it to the WhatsappComponents field.
func (o *WebhookEventMessageDataTemplate) SetWhatsappComponents(v []WhatsAppTemplateMessageComponent) {
	o.WhatsappComponents = v
}

func (o WebhookEventMessageDataTemplate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventMessageDataTemplate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.Internal) {
		toSerialize["internal"] = o.Internal
	}
	if !IsNil(o.InternalComponents) {
		toSerialize["internal_components"] = o.InternalComponents
	}
	if !IsNil(o.Whatsapp) {
		toSerialize["whatsapp"] = o.Whatsapp
	}
	if !IsNil(o.WhatsappComponents) {
		toSerialize["whatsapp_components"] = o.WhatsappComponents
	}
	return toSerialize, nil
}

type NullableWebhookEventMessageDataTemplate struct {
	value *WebhookEventMessageDataTemplate
	isSet bool
}

func (v NullableWebhookEventMessageDataTemplate) Get() *WebhookEventMessageDataTemplate {
	return v.value
}

func (v *NullableWebhookEventMessageDataTemplate) Set(val *WebhookEventMessageDataTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventMessageDataTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventMessageDataTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventMessageDataTemplate(val *WebhookEventMessageDataTemplate) *NullableWebhookEventMessageDataTemplate {
	return &NullableWebhookEventMessageDataTemplate{value: val, isSet: true}
}

func (v NullableWebhookEventMessageDataTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventMessageDataTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


